"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    parseDir: function() {
        return parseDir;
    },
    getApiPaths: function() {
        return getApiPaths;
    },
    dynamicSegmentRegex: function() {
        return dynamicSegmentRegex;
    },
    isDynamicSegment: function() {
        return isDynamicSegment;
    },
    catchAllSegmentRegex: function() {
        return catchAllSegmentRegex;
    },
    isCatchAllSegment: function() {
        return isCatchAllSegment;
    },
    routeGroupSegmentRegex: function() {
        return routeGroupSegmentRegex;
    },
    isRouteGroupSegment: function() {
        return isRouteGroupSegment;
    }
});
var _core = require("@swc/core");
var _promises = require("fs/promises");
var _path = /*#__PURE__*/ _interop_require_default(require("path"));
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _interop_require_default(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
function _ts_values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function() {
            if (o && i >= o.length) o = void 0;
            return {
                value: o && o[i++],
                done: !o
            };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function parseDir(dir, parent, initialSegment) {
    return _parseDir.apply(this, arguments);
}
function _parseDir() {
    _parseDir = _async_to_generator(function(dir, parent, initialSegment) {
        var filesAndFolders, folderName, segment, hasHandler, route, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, file, filePath, child, err;
        return _ts_generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        (0, _promises.readdir)(dir)
                    ];
                case 1:
                    filesAndFolders = _state.sent();
                    folderName = _path.default.basename(dir);
                    segment = initialSegment !== null && initialSegment !== void 0 ? initialSegment : getSegment(folderName);
                    hasHandler = filesAndFolders.includes("route.ts");
                    route = {
                        path: dir,
                        children: [],
                        segment: segment,
                        parent: parent,
                        hasHandler: hasHandler
                    };
                    _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    _state.label = 2;
                case 2:
                    _state.trys.push([
                        2,
                        8,
                        9,
                        10
                    ]);
                    _iterator = filesAndFolders[Symbol.iterator]();
                    _state.label = 3;
                case 3:
                    if (!!(_iteratorNormalCompletion = (_step = _iterator.next()).done)) return [
                        3,
                        7
                    ];
                    file = _step.value;
                    filePath = _path.default.join(dir, file);
                    return [
                        4,
                        (0, _promises.stat)(filePath)
                    ];
                case 4:
                    if (!_state.sent().isDirectory()) return [
                        3,
                        6
                    ];
                    return [
                        4,
                        parseDir(filePath, route)
                    ];
                case 5:
                    child = _state.sent();
                    if (child) route.children.push(child);
                    _state.label = 6;
                case 6:
                    _iteratorNormalCompletion = true;
                    return [
                        3,
                        3
                    ];
                case 7:
                    return [
                        3,
                        10
                    ];
                case 8:
                    err = _state.sent();
                    _didIteratorError = true;
                    _iteratorError = err;
                    return [
                        3,
                        10
                    ];
                case 9:
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                    return [
                        7
                    ];
                case 10:
                    if (!route.hasHandler && route.children.length === 0) {
                        return [
                            2,
                            null
                        ];
                    }
                    return [
                        2,
                        route
                    ];
            }
        });
    });
    return _parseDir.apply(this, arguments);
}
function getApiPaths(route) {
    return _getApiPaths.apply(this, arguments);
}
function _getApiPaths() {
    _getApiPaths = _async_to_generator(function(route) {
        var urls, routesWithHandlers, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _loop, _iterator, _step, err;
        return _ts_generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    urls = [];
                    routesWithHandlers = getRoutesWithHandlers(route);
                    _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    _state.label = 1;
                case 1:
                    _state.trys.push([
                        1,
                        6,
                        7,
                        8
                    ]);
                    _loop = function() {
                        var _$route, segments, filepath, url, params, methods;
                        return _ts_generator(this, function(_state) {
                            switch(_state.label){
                                case 0:
                                    _$route = _step.value;
                                    segments = getRoutePath(_$route);
                                    filepath = _$route.path + "/route.ts";
                                    url = segments.filter(function(s) {
                                        return s.segment.type !== "group";
                                    }).map(function(s) {
                                        return s.segment.type === "static" ? s.segment.value : s.segment.type === "catchAll" ? "*".concat(s.segment.value) : ":".concat(s.segment.value);
                                    }).join("/");
                                    params = segments.filter(function(s) {
                                        return s.segment.type === "param" || s.segment.type === "catchAll";
                                    }).reduce(function(acc, s) {
                                        if (acc[s.segment.value]) {
                                            console.log("WARNING: Ignored duplicate param: ".concat(s.segment.value, " in route: ").concat(url, " in file: ").concat(filepath));
                                            return acc;
                                        }
                                        acc[s.segment.value] = s.segment.type === "param" ? "string" : "array";
                                        return acc;
                                    }, {});
                                    return [
                                        4,
                                        getNamedExports(filepath)
                                    ];
                                case 1:
                                    methods = _state.sent().reduce(function(acc, name) {
                                        if ([
                                            "GET",
                                            "POST",
                                            "PUT",
                                            "PATCH",
                                            "DELETE",
                                            "HEAD",
                                            "OPTIONS"
                                        ].includes(name)) {
                                            acc[name] = true;
                                        }
                                        return acc;
                                    }, {});
                                    if (!Object.values(methods).some(function(v) {
                                        return v;
                                    })) {
                                        console.log("WARNING: No handler methods found for route: ".concat(url, " in file: ").concat(filepath));
                                        return [
                                            2,
                                            "continue"
                                        ];
                                    }
                                    urls.push({
                                        filepath: filepath,
                                        url: url,
                                        params: params,
                                        methods: methods
                                    });
                                    return [
                                        2
                                    ];
                            }
                        });
                    };
                    _iterator = routesWithHandlers[Symbol.iterator]();
                    _state.label = 2;
                case 2:
                    if (!!(_iteratorNormalCompletion = (_step = _iterator.next()).done)) return [
                        3,
                        5
                    ];
                    return [
                        5,
                        _ts_values(_loop())
                    ];
                case 3:
                    _state.sent();
                    _state.label = 4;
                case 4:
                    _iteratorNormalCompletion = true;
                    return [
                        3,
                        2
                    ];
                case 5:
                    return [
                        3,
                        8
                    ];
                case 6:
                    err = _state.sent();
                    _didIteratorError = true;
                    _iteratorError = err;
                    return [
                        3,
                        8
                    ];
                case 7:
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                    return [
                        7
                    ];
                case 8:
                    return [
                        2,
                        urls
                    ];
            }
        });
    });
    return _getApiPaths.apply(this, arguments);
}
function getRoutePath(route) {
    var segments = [];
    var currentRoute = route;
    while(currentRoute){
        segments.unshift(currentRoute);
        currentRoute = currentRoute.parent;
    }
    return segments;
}
function getRoutesWithHandlers(route) {
    var routes = [];
    if (route.hasHandler) {
        routes.push(route);
    }
    route.children.forEach(function(child) {
        var _routes;
        (_routes = routes).push.apply(_routes, _to_consumable_array(getRoutesWithHandlers(child)));
    });
    return routes;
}
function getSegment(folderName) {
    if (isDynamicSegment(folderName)) {
        var result = dynamicSegmentRegex.exec(folderName);
        return {
            type: "param",
            value: (result === null || result === void 0 ? void 0 : result[1]) || ""
        };
    }
    if (isCatchAllSegment(folderName)) {
        var result1 = catchAllSegmentRegex.exec(folderName);
        return {
            type: "catchAll",
            value: (result1 === null || result1 === void 0 ? void 0 : result1[1]) || ""
        };
    }
    if (isRouteGroupSegment(folderName)) {
        var result2 = routeGroupSegmentRegex.exec(folderName);
        return {
            type: "group",
            value: (result2 === null || result2 === void 0 ? void 0 : result2[1]) || ""
        };
    }
    return {
        type: "static",
        value: folderName
    };
}
var dynamicSegmentRegex = /\[((?!\.\.\.).*)\]/;
var isDynamicSegment = function(segment) {
    return dynamicSegmentRegex.test(segment);
};
var catchAllSegmentRegex = /\[\.\.\.(.*)\]/;
var isCatchAllSegment = function(segment) {
    return catchAllSegmentRegex.test(segment);
};
var routeGroupSegmentRegex = /\((.*)\)/;
var isRouteGroupSegment = function(segment) {
    return routeGroupSegmentRegex.test(segment);
};
function getNamedExports(filepath) {
    return _getNamedExports.apply(this, arguments);
}
function _getNamedExports() {
    _getNamedExports = _async_to_generator(function(filepath) {
        var code, ast, exports1, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, item, declaration, declarations, _iteratorNormalCompletion1, _didIteratorError1, _iteratorError1, _iterator1, _step1, variableDeclarator, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, specifier;
        return _ts_generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        (0, _promises.readFile)(filepath, {
                            encoding: "utf8"
                        })
                    ];
                case 1:
                    code = _state.sent();
                    return [
                        4,
                        (0, _core.parse)(code, {
                            syntax: "typescript"
                        })
                    ];
                case 2:
                    ast = _state.sent();
                    exports1 = [];
                    _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    try {
                        for(_iterator = ast.body[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                            item = _step.value;
                            if (item.type === "ExportDeclaration") {
                                declaration = item.declaration;
                                if (declaration.type === "VariableDeclaration") {
                                    declarations = declaration.declarations;
                                    _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                                    try {
                                        for(_iterator1 = declarations[Symbol.iterator](); !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                                            variableDeclarator = _step1.value;
                                            if (variableDeclarator.id.type === "Identifier") exports1.push(variableDeclarator.id.value);
                                        }
                                    } catch (err) {
                                        _didIteratorError1 = true;
                                        _iteratorError1 = err;
                                    } finally{
                                        try {
                                            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                                _iterator1.return();
                                            }
                                        } finally{
                                            if (_didIteratorError1) {
                                                throw _iteratorError1;
                                            }
                                        }
                                    }
                                } else if (declaration.type === "FunctionDeclaration") exports1.push(declaration.identifier.value);
                            } else if (item.type === "ExportNamedDeclaration") {
                                _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = undefined;
                                try {
                                    for(_iterator2 = item.specifiers[Symbol.iterator](); !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true){
                                        specifier = _step2.value;
                                        if (specifier.type === "ExportSpecifier") {
                                            if (specifier.exported) exports1.push(specifier.exported.value);
                                            else exports1.push(specifier.orig.value);
                                        }
                                    }
                                } catch (err) {
                                    _didIteratorError2 = true;
                                    _iteratorError2 = err;
                                } finally{
                                    try {
                                        if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                                            _iterator2.return();
                                        }
                                    } finally{
                                        if (_didIteratorError2) {
                                            throw _iteratorError2;
                                        }
                                    }
                                }
                            }
                        }
                    } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                    } finally{
                        try {
                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                _iterator.return();
                            }
                        } finally{
                            if (_didIteratorError) {
                                throw _iteratorError;
                            }
                        }
                    }
                    return [
                        2,
                        exports1
                    ];
            }
        });
    });
    return _getNamedExports.apply(this, arguments);
}
