import { NextRequest, NextResponse } from "next/server";
import { z } from "zod";
import { ContextBase, RequestHandler, RouteParamsBase } from "./handler-types";
import { UseContext } from "./use-context";
export declare abstract class UseFinishRequest<RouteParams extends RouteParamsBase, QueryParams extends z.SomeZodObject, Cookies extends z.SomeZodObject, Body extends z.SomeZodObject, InputContext extends ContextBase, OutputContext extends ContextBase> extends UseContext<RouteParams, QueryParams, Cookies, Body, InputContext, OutputContext> {
    protected constructor();
    private finish;
    get<D extends object>(handler: RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, undefined, OutputContext, D>): (req: NextRequest, options: any, _typeInfo?: {
        method: "GET";
        body: z.TypeOf<Body>;
        params: RouteParams;
        query: z.TypeOf<QueryParams>;
        cookies: z.TypeOf<Cookies>;
        data: D;
    } | undefined) => Promise<NextResponse>;
    post<D extends object>(handler: RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, z.TypeOf<Body>, OutputContext, D>): (req: NextRequest, options: any, _typeInfo?: {
        method: "POST";
        body: z.TypeOf<Body>;
        params: RouteParams;
        query: z.TypeOf<QueryParams>;
        cookies: z.TypeOf<Cookies>;
        data: D;
    } | undefined) => Promise<NextResponse>;
    put<D extends object>(handler: RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, z.TypeOf<Body>, OutputContext, D>): (req: NextRequest, options: any, _typeInfo?: {
        method: "PUT";
        body: z.TypeOf<Body>;
        params: RouteParams;
        query: z.TypeOf<QueryParams>;
        cookies: z.TypeOf<Cookies>;
        data: D;
    } | undefined) => Promise<NextResponse>;
    patch<D extends object>(handler: RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, z.TypeOf<Body>, OutputContext, D>): (req: NextRequest, options: any, _typeInfo?: {
        method: "PATCH";
        body: z.TypeOf<Body>;
        params: RouteParams;
        query: z.TypeOf<QueryParams>;
        cookies: z.TypeOf<Cookies>;
        data: D;
    } | undefined) => Promise<NextResponse>;
    delete<D extends object>(handler: RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, undefined, OutputContext, D>): (req: NextRequest, options: any, _typeInfo?: {
        method: "DELETE";
        body: z.TypeOf<Body>;
        params: RouteParams;
        query: z.TypeOf<QueryParams>;
        cookies: z.TypeOf<Cookies>;
        data: D;
    } | undefined) => Promise<NextResponse>;
    head<D extends object>(handler: RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, undefined, OutputContext, D>): (req: NextRequest, options: any, _typeInfo?: {
        method: "HEAD";
        body: z.TypeOf<Body>;
        params: RouteParams;
        query: z.TypeOf<QueryParams>;
        cookies: z.TypeOf<Cookies>;
        data: D;
    } | undefined) => Promise<NextResponse>;
    options<D extends object>(handler: RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, undefined, OutputContext, D>): (req: NextRequest, options: any, _typeInfo?: {
        method: "OPTIONS";
        body: z.TypeOf<Body>;
        params: RouteParams;
        query: z.TypeOf<QueryParams>;
        cookies: z.TypeOf<Cookies>;
        data: D;
    } | undefined) => Promise<NextResponse>;
}
